

#include "notetest.hpp"

void main()
{
  Settings* pWin = new Settings();

  IApplication::current().run();
}

Settings::Settings ( )
         :IFrameWindow ( ID_SETTINGS )
{
  setAutoDeleteObject  ( true );

  pNotebook = new INotebook ( ID_NOTEBOOK, this, this );

  setClient ( pNotebook );

  pNotebook->show();

  IFrameWindow* pPage = new IFrameWindow( DLG_NOTEBOOKPAGE,
                                          pNotebook,
                                          pNotebook );

  INotebook::PageSettings pgSett ( INotebook::PageSettings::statusTextOn |
                                   INotebook::PageSettings::autoPageSize );

  IPageHandle pageHandle = pNotebook->addLastPage ( pgSett, pPage );

  pNotebook->setStatusText ( pageHandle, "close me using ALT-F4" );

  show();
}

Settings::~Settings ()
{
  delete pNotebook;
}
